// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function extractEmails (text) {
    text = text.replaceAll('<b>', '').replaceAll('</b>', '');
    return text.match(/([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)/gi);
}

function get_emails_filter(emails = []){
    var forbidden_keys = ['1.8.1','.cart', '.index', '.collection',
            '.js', 'template.404','tel:', 'mailto:', '.jpg', '.pdf', '.doc',
            '.xls', '.xlsx', '.png', '.jpeg', '.webp', '.gif', 'javascript:',
            'skype', '#', 'None', '.svg', 'desktop.ts', 'example', 'css', '.studio', 'image', 'jquery', 'swiper', 'myshopline.com',
            'img_', 'xxx.xxx', 'foundation-sites', 'exemple@mail.com', 'exemple@gmail.be', 'exemple@mail.ch', 'john@email.com',
            'your.email@address.com', 'stores@domain.com', 'test@email.com', 'first.last@company.com', 'you@email.com', 'your-email@shopify.com',
            'ada@ada.lt', 'johndoe@domain.com', 'your@email.com', 'jane.smith@email.com', 'abc@xyz.com', 'user@domain.com', 'template.account@template.blog',
            'john@test.com', 'emily@test.com', 'email@domain.com', 'yourname@email.com', 'jill@mail.com', 'joebloggs@email.com', 'abc@abc.abc', 'support@domain.com', 'yellow@hello.com'];
    var domain_emails = [];
    if(emails && emails.length>0){
        for(j=0;j<emails.length;j++){
            var current_email = emails[j];
            current_email = current_email.toLowerCase().trim();
            //把字符串最后一个.移除掉
            if(current_email[current_email.length-1] == '.'){
                current_email = current_email.slice(0,-1);
            }
            //排除有些如 .png
            var is_forbidden = false;
            for(k=0;k<forbidden_keys.length;k++){
                if(current_email.indexOf(forbidden_keys[k])!=-1){
                    is_forbidden = true;
                    break;
                }
            }
            //leaflet@1.8.0
            let current_email_arr = current_email.split('@');
            if(current_email_arr.length > 1){
                let current_a_houzhui = current_email_arr[1];
                let current_a_houzhui_arr = current_a_houzhui.split('.');
                let is_num_shuliang = 0;
                for(let k=0;k<current_a_houzhui_arr.length;k++){
                    if(util_isnumber(current_a_houzhui_arr[k])){
                        is_num_shuliang +=1;
                    }
                }
                if(is_num_shuliang >=2){
                    is_forbidden = true;
                }
            }
            //
            if(!is_forbidden && !domain_emails.includes(current_email)){
                domain_emails.push(current_email);
            }
            //
        }
    }
    return domain_emails;
}

function util_checkFanpa(str = ''){
    const searchString = "This item is sold out";
    const regex = new RegExp(searchString);
    const containsString = regex.test(str);
    if(containsString){
        return true;
    } else {
        return false;
    }
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_page_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_page';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_page: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_page: 0}, callback);
            }else{
                chrome.storage.local.set({pause_page: 1}, callback);
            }
        }
    });
}

// Function to convert an image to a Blob
async function imageToBlob(imageUrl) {
  try {
    // Fetch the image as an array buffer
    const response = await fetch(imageUrl);
    const arrayBuffer = await response.arrayBuffer();

    // Create a Blob from the array buffer
    const blob = new Blob([arrayBuffer], { type: response.headers.get("content-type") });

    return blob;
  } catch (error) {
    console.error("Error converting image to Blob:", error);
    return null;
  }
}

// Usage example:
/*const imageUrl = "https://img.kwcdn.com/product/Fancyalgo/VirtualModelMatting/8af63f79afdd388711b1c34289c15cda.jpg?imageView2/2/w/800/q/70/format/webp";
imageToBlob(imageUrl)
  .then(blob => {
    if (blob) {
      // Do something with the Blob, such as uploading it or displaying it
        console.log('aaaa');
        console.log(blob);
    } else {
        console.log("Failed to convert image to Blob.");
    }
  });*/

function urlToBase64(url, callback) {
  const xhr = new XMLHttpRequest();
  xhr.onload = function() {
    const reader = new FileReader();
    reader.onloadend = function() {
      callback(reader.result);
    };
    reader.readAsDataURL(xhr.response);
  };
  xhr.open('GET', url);
  xhr.responseType = 'blob';
  xhr.send();
}

// 使用示例
/*const imageUrl = 'https://example.com/image.jpg'; // 替换为你自己的图片URL
urlToBase64(imageUrl, function(base64String) {
  console.log(base64String); // 这里是Base64编码的图片字符串
});*/
//
function storage_shangjia_about_contact_and_basic_info_set(_shangjia_info={}, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_info['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': _shangjia_info['_shangjia_id'],
                '_shangjia_name': _shangjia_info['_shangjia_name'],
                '_shangjia_about_contact_and_basic_info_link':_shangjia_info['_shangjia_a_link'],
                '_shangjia_add_time': Date.now(),

                '_is_request':0,
                '_seller_page_url': '',
                '_seller_id':'',
                '_seller_chongfu':0,

                '_seller_page_url_is_request':0,
                '_seller_name': '',
                '_seller_type': '',
                '_seller_review_num':'',
                '_seller_business_name':'',
                '_seller_phone':'',
                '_seller_address':'',
                '_seller_country':'',
                '_seller_about':'',
                '_seller_email':''
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function request_shangjia_about_contact_and_basic_info_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        console.log('request_shangjia_about_contact_and_basic_info_ajax:'+need_item['_shangjia_about_contact_and_basic_info_link']);
        //
        $.ajax({
            url:need_item['_shangjia_about_contact_and_basic_info_link'],
            timeout : 5000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
               let _dom = $(data);
               //

               //
               let _mainContent = _dom.find('.mainContent').text();
               let _baseContent = _dom.find('.baseContent').text();
               let _checkContent = _mainContent;
               if(_baseContent){
                   _checkContent += _baseContent;
               }
               if(util_checkFanpa(_checkContent)){
                   //
                    need_item['_is_request'] = 0;
                    need_item['_error'] = '遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!';
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                            //

                            //
                    });
                    sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!");
                    //
               }else{
                   //
                   let _seller_page_url = _dom.find("a[data-testid='view-seller-info-link']").attr('href');
                   if(_seller_page_url){
                       need_item['_seller_page_url'] = 'https://www.walmart.com'+_seller_page_url;
                       //
                       let _seller_page_url_arr = _seller_page_url.split('?');
                       if(_seller_page_url_arr){
                           let _seller_id = _seller_page_url_arr[0];
                           _seller_id = _seller_id.replace('/seller/','');
                           need_item['_seller_id'] = _seller_id;
                       }
                       //
                   }
                   need_item['_seller_name'] = _dom.find("div[data-testid='sold-and-shipped-by'] .lh-copy .black-90").text();
                   need_item['_is_request'] = 2;
                   if(need_item['_seller_page_url'] == ''){
                       need_item['_seller_page_url_is_request'] =2;
                   }
                   need_item['_e_time'] = Date.now();
                   //
                   let obj = {};
                   obj[storage_key] = need_item;
                   chrome.storage.local.set(obj, function (){
                   });
                   //
                   /*if(need_item['_shangjia_img']){
                       urlToBase64(need_item['_shangjia_img'], function(base64String) {
                           //console.log(blob);
                            //need_item['_shangjia_img_blob'] = base64String;
                            //
                            need_item['_is_request'] = 2;
                            need_item['_e_time'] = Date.now();
                            let obj = {};
                            obj[storage_key] = need_item;
                            chrome.storage.local.set(obj, function (){
                            });
                            //
                        });
                   }*/
                   //
               }
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
                //
                if(jqXHR.status == 404){
                    need_item['_is_request'] = 2;
                }else{
                    need_item['_is_request'] = 0;
                }
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                        //

                        //
                });
                //
            }
        });
        //
    })
}

function request_shangjia_about_contact_and_basic_info(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-10000))){
                    need_item = items[key];
                    need_item['_is_request'] = 1;
                    need_item['_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_about_contact_and_basic_info_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}

function request_shangjia_company_page_link_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        console.log('request_shangjia_company_page_link_ajax:'+need_item['_seller_page_url']);
        //
        for(let key in items){
            //console.log('key');
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                if(storage_key != key &&
                    items[key]['_seller_id'] == need_item['_seller_id'] &&
                    items[key]['_seller_page_url_is_request'] ==2){
                    console.log(key);
                    console.log(storage_key);
                    need_item['_seller_chongfu'] = 1;
                    need_item['_seller_page_url_is_request'] = 2;
                    need_item['_seller_page_url_s_time'] = Date.now();
                    let obj = {};
                    obj[storage_key] = need_item;
                    //console.log(need_item);
                    chrome.storage.local.set(obj, function (){
                        console.log('storage_key:'+storage_key+' is set');
                    });
                    break;
                    return false;
                }
            }
        }
        //
        //
        $.ajax({
            url:need_item['_seller_page_url'],
            timeout : 5000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
                data = data.replace('script','div');
                //console.log('data');
                //console.log(data);
               var $html = $(data);
               //
                /**
                '_seller_page_url': '',
                '_seller_page_url_is_request':0,
                '_seller_name': '',
                '_seller_type': '',
                '_seller_review_num':'',
                '_seller_business_name':'',
                '_seller_phone':'',
                '_seller_address':'',
                '_seller_country':'',
                '_seller_about':'',
                '_seller_email':''
                 */
               need_item['_seller_type'] = $html.find("div[data-testid='desktop-container'] h1 .items-center").text();
               $html.find(".mt4 section.di button").each(function (){
                   let _text = $(this).text();
                   if(_text.indexOf('reviews') != -1){
                       need_item['_seller_review_num'] = _text;
                       return false;
                   }
               });
               $html.find('section.di').children('.mt3').each(function (){
                  let _text = $(this).find('.f6').text();
                  if(_text.indexOf('Business Name') != -1){
                      need_item['_seller_business_name'] = _text;
                  }
               });
               //
               need_item['_seller_about'] = $html.find('#AboutSeller').text();
               //
               if(need_item['_seller_about']){
                    let emails = extractEmails($html.find('#AboutSeller').html());
                    let domain_emails = get_emails_filter(emails);
                    //
                    if(domain_emails.length > 0){
                        need_item['_seller_email'] = domain_emails.join(',');
                    }
               }
                //
                let _inner_json_str = $html.find('#__NEXT_DATA__').text();
                let _inner_json = JSON.parse(_inner_json_str);
                //console.log(_inner_json);
                //
                if(_inner_json){
                    need_item['_seller_address'] = _inner_json['props']['pageProps']['initialData']['data']['seller']['address1']+','+_inner_json['props']['pageProps']['initialData']['data']['seller']['address2']+', '+_inner_json['props']['pageProps']['initialData']['data']['seller']['city']+', '+_inner_json['props']['pageProps']['initialData']['data']['seller']['state']+', '+_inner_json['props']['pageProps']['initialData']['data']['seller']['country'];
                    need_item['_seller_country'] = _inner_json['props']['pageProps']['initialData']['data']['seller']['country'];
                    if(need_item['_seller_email'] == ''){
                        need_item['_seller_email'] = _inner_json['props']['pageProps']['initialData']['data']['seller']['sellerEmail'];
                    }
                    need_item['_seller_type'] = _inner_json['props']['pageProps']['initialData']['data']['seller']['sellerType'];
                }

                //

               $html.find('section.di .lh-title a').each(function (){
                  let _a_href = $(this).attr('href');
                  if(_a_href.indexOf('tel') !=-1){
                      need_item['_seller_phone'] = $(this).text();
                  }
               });

                //
               need_item['_seller_page_url_is_request'] = 2;
               let obj = {};
               obj[storage_key] = need_item;
               chrome.storage.local.set(obj, function (){
               });
               //
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
                //
                if(jqXHR.status == 404){
                    need_item['_seller_page_url_is_request'] = 2;
                }else{
                    need_item['_seller_page_url_is_request'] = 0;
                }
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                    //
                    //
                });
                //
            }
        });
        //
    })
}

function request_shangjia_company_page_link(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                if(items[key]['_is_request'] == 2 && items[key]['_seller_page_url'] && (items[key]['_seller_page_url_is_request'] == 0 || (items[key]['_seller_page_url_is_request'] == 1 && items[key]['_seller_page_url_s_time'] < (Date.now()-10000)))){
                    need_item = items[key];
                    need_item['_seller_page_url_is_request'] = 1;
                    need_item['_seller_page_url_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_company_page_link_ajax(key);
                        //
                    });
                    break;
                }
                //
                if(items[key]['_is_request'] == 2 && items[key]['_seller_page_url']==''){
                    need_item = items[key];
                    need_item['_seller_page_url_is_request'] = 2;
                    need_item['_seller_page_url_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                    });
                }
                //
            }
        }
        //
    });
}

function xintiao(){
     chrome.storage.local.get(null, function(items) {
         if(items.hasOwnProperty('pause') == false || items['pause'] == 0){
             console.log('爬取中');
             request_shangjia_about_contact_and_basic_info();
             request_shangjia_company_page_link();
         }else{
             console.log('已暂停爬取');
         }
    });

    //request_shangjia_about_work_and_education_link();
    //request_shangjia_company_page_link();
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });
    //let str = '';

    //let _dom = $(str);
    //https://www.facebook.com/gabriella.obi.77/about_work_and_education
    //
    //let _shangjia_company_page_link = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').attr('href');
    //console.log(_shangjia_company_page_link);

    //let _shangjia_company_page_name = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').text();
    //console.log(_shangjia_company_page_name);
}
xintiao();
setInterval(xintiao, 10000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_about_work_and_education_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'shangjias'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_geren_num = 0;
    let has_caiji_company_num = 0;
    let seller_id_arr = [];
    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2 && items[key]['_seller_page_url_is_request'] == 2){
                    has_caiji_geren_num += 1;
                    //
                    if(seller_id_arr.includes(items[key]['_seller_id']) == false){
                        seller_id_arr.push(items[key]['_seller_id']);
                    }
                    //
                }
            }
        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_geren_num': has_caiji_geren_num,
            'has_caiji_company_num': has_caiji_company_num,
            'has_caiji_seller_num': seller_id_arr.length
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_shangjias_update(shangjia_infos=[]){
    //console.log('storage_shangjias_update a');
    chrome.storage.local.get('shangjias', function(items) {
        //console.log('storage_shangjias_update b');
        //console.log(items);
        if(!items.hasOwnProperty('shangjias')){
            let obj = {};
            let shangjias = [];
            for(let i=0;i<shangjia_infos.length;i++){
                if(!shangjias.includes(shangjia_infos[i]['_shangjia_id'])){
                    shangjias.push(shangjia_infos[i]['_shangjia_id']);
                }
            }
            obj['shangjias'] = shangjias;
            chrome.storage.local.set(obj);
        }else{
            let storage_shangjias = items['shangjias'];

            for(let i=0;i<shangjia_infos.length;i++){
                //let is_exists = false;
                //for(let j=0;j<storage_shangjias.length;j++){
                //    if(shangjia_infos[i]['_shangjia_id'] == storage_shangjias[j]){
                 //       is_exists = true;
                 //       break;
                  //  }
               // }
                //
                //if(!is_exists){
                    if(!storage_shangjias.includes(shangjia_infos[i]['_shangjia_id'])){
                        storage_shangjias.push(shangjia_infos[i]['_shangjia_id']);
                    }
                //}
                //
            }
            //
            let obj = {};
            obj['shangjias'] = storage_shangjias;
            chrome.storage.local.set(obj);
            //
        }
    })
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'shangjia_items_update') {
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        storage_shangjias_update(shangjia_infos);
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],function (){

            });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过3000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_page') || items['pause_page'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 3000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }
  }
);

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */

function sendPopTips(msg = ''){
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}